Description

These days softphones are very popular and used by many employees. It would be great if Redmine could create links with the tel

protocol to let users make calls quickly and effortless.

It's a small change but can significantly increase the comfort for users.

Related issues:

Related to Redmine - Feature #10889: Add support for the 'tel' URL protocol h... New

History

#1 - 2024-12-06 08:09 - Bernhard Rohloff

- Related to Feature #10889: Add support for the 'tel' URL protocol handler added

#2 - 2024-12-06 19:54 - Holger Just

Your patch does (probably?) not solve the underlying issue and is at the wrong place.

uri_with_safe_scheme? is intended to validate the schemes of URLs of e.g. <img> tags or other resources which cause the browser to load them

directly. The correct method to use for links would be uri_with_link_safe_scheme? instead.

With that being said, uri_with_safe_scheme? is the oldest of these related methods and its semantics have changed slightly over time. It might be that

this method is sill erroneously used in places where uri_with_link_safe_scheme? should be used instead.

In any case, please also provide some tests for changed behavior. This is especially important here since these changes may cause new XSS

vulnerabilities in Redmine if we are not careful.

#3 - 2024-12-09 15:03 - Bernhard Rohloff

- File unit_test_for_add_tel_to_custom_field_url_pattern.diff added

Holger Just wrote in #note-2:

Your patch does (probably?) not solve the underlying issue and is at the wrong place.

uri_with_safe_scheme? is intended to validate the schemes of URLs of e.g. <img> tags or other resources which cause the browser to load them

directly. The correct method to use for links would be uri_with_link_safe_scheme? instead.

With that being said, uri_with_safe_scheme? is the oldest of these related methods and its semantics have changed slightly over time. It might

be that this method is sill erroneously used in places where uri_with_link_safe_scheme? should be used instead.

In any case, please also provide some tests for changed behavior. This is especially important here since these changes may cause new XSS

vulnerabilities in Redmine if we are not careful.

 The propsed change is only meant for providing the ability of creating links for phone numbers in custom fields. It's solving the issue as the method

uri_with_link_safe_scheme? whitelists the allowed protocols for links and is used by source:trunk/lib/redmine/field_format.rb#L217. I've tested the

solution and it's working in my dev environment. The patch just adds the :tel scheme to the list. Attached is a patch for extending the existing unit test

of the proposed change.

#4 - 2025-01-23 13:38 - Stephan Meyer

Hello, thanks for your support. Any news on this ticket?

#5 - 2025-01-28 12:47 - Bernhard Rohloff

- Status changed from New to Needs feedback
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/field_format.rb#L217


Right now, this ticket is stale and maybe feedback of Go MAEDA is needed here.

I've taken a second look on the useage of the uri_with_safe_scheme? function.

It's used in three places in the codebase:

To validate the fields format: source:trunk/lib/redmine/field_format.rb#L220

For image inlining in textile formatting: source:trunk/lib/redmine/wiki_formatting/textile/redcloth3.rb#L844

For displaying the project homepage link in the overview: source:trunk/app/views/projects/show.html.erb#L40

Holger Just would it be better to refactor the code of the field validation? I think it would be really cool to make a phonecall by a click on a custom

field.

Files

add_tel_to_custom_field_url_pattern.diff 660 Bytes 2024-12-06 Bernhard Rohloff

unit_test_for_add_tel_to_custom_field_url_pattern.diff 585 Bytes 2024-12-09 Bernhard Rohloff
